Cunning Gena - Codeforces 417D


https://codeforces.com/problemset/problem/417/D

A boy named Gena really wants to get to the "Russian Code Cup" finals, or at least get a t-shirt. But the offered problems are too complex, so he made an arrangement with his n friends that they will solve the problems for him.
The participants are offered m problems on the contest. For each friend, Gena knows what problems he can solve. But Gena's friends won't agree to help Gena for nothing: the i-th friend asks Gena xi rubles for his help in solving all the problems he can. Also, the friend agreed to write a code for Gena only if Gena's computer is connected to at least ki monitors, each monitor costs b rubles.
Gena is careful with money, so he wants to spend as little money as possible to solve all the problems. Help Gena, tell him how to spend the smallest possible amount of money. Initially, there's no monitors connected to Gena's computer.
Input
The first line contains three integers nm and b (1 ≤ n ≤ 1001 ≤ m ≤ 201 ≤ b ≤ 109) — the number of Gena's friends, the number of problems and the cost of a single monitor.
The following 2n lines describe the friends. Lines number 2i and (2i + 1) contain the information about the i-th friend. The 2i-th line contains three integers xiki and mi (1 ≤ xi ≤ 1091 ≤ ki ≤ 1091 ≤ mi ≤ m) — the desired amount of money, monitors and the number of problems the friend can solve. The (2i + 1)-th line contains mi distinct positive integers — the numbers of problems that the i-th friend can solve. The problems are numbered from 1 to m.
Output
Print the minimum amount of money Gena needs to spend to solve all the problems. Or print -1, if this cannot be achieved
input
Copy
2 2 1
100 1 1
2
100 2 1
1
output
Copy
202
input
Copy
3 2 5
100 1 1
1
100 1 1
2
200 1 2
1 2
output
Copy
205
input
Copy
1 2 1
1 1 1
1
output
Copy
-1
http://my-zhang.github.io/blog/2014/04/20/dynamic-programming-with-bitmask/
typedef long long ll;

struct Friend {
    int id;     // friend id.
    ll cost;    // the cost of solving problems.
    ll monitor; // the necessary num of monitors.
    int solves; // the bitmask of solvable problems.
};

bool cmp(Friend a, Friend b) {
    return a.monitor < b.monitor;
}

Friend friends[N];
ll dp[1<<M];

int main() {
    int n, m;   // number of friends and problems.
    ll b;       // cost of monitor.
    cin >> n >> m >> b;

    for(int i = 0; i < (1<<m); i++) {
        dp[i] = INF; // initially marked as impossible. 
    }
    dp[0] = 0;

    /* input processing. */
    for(int i = 0; i < n; i++) {
        ll cost, monitor, num;
        int solves = 0;
        cin >> cost >> monitor >> num;
        for(int j = 0; j < num; j++) {
            int qid;
            cin >> qid;
            solves |= (1 << (qid-1));
        }
        friends[i] = (Friend){i+1, cost, monitor, solves};
    }

    // start with the friend with minimum monitor number.
    sort(friends, friends+n, cmp);

    ll min_cost = INF;
    for(int fid = 0; fid < n; fid++) {
        Friend f = friends[fid];
        for(int i = 0; i < (1<<m); i++) {
            if(dp[i] == INF) {
                continue;
            }
            if(dp[i | f.solves] == INF) {
                dp[i | f.solves] = dp[i] + f.cost;
            }
            else {
                dp[i | f.solves] = min(dp[i | f.solves], dp[i] + f.cost);
            }
        }
        if(dp[(1<<m) - 1] != INF) {
            if(min_cost == INF) {
                min_cost = (dp[(1<<m) - 1] + f.monitor * b);
            }
            else {
                min_cost = min(min_cost, dp[(1<<m) - 1] + f.monitor * b);
            }
        }
    }

    cout << min_cost << endl;
}

1. 题意:你要让n个朋友做完m道题,每个人能做掉特定某些题目,有一个花费x和需要的monitor(班长)个数,每个monitor(监视器)需要一定花费,但是monitor(显示屏)可以给所有朋友公用。求做完所有题的最小花费。(e.i. m很小)
2. 思路:m很小,所以压缩m的所有状态。f[state]表示做了state状态所花费的最小费用(不买monitor)。然而monitor还是需要管的,所以把所有朋友按monitor数量升序排序,这样每次用一个朋友更新状态时他自己必然是需要monitor最多的,那就拿他自己的monitor数量更新就好了。
3. 实现:排序+状压DP
4. 曾经的错误思路:monitor数量降序排列,然后f[state]表示加上monitor之后的最小价值,g[state]表示对应的f[state]状态去掉monitor花费后的价格。因为降序,所以所有f[nxt]都是由已经拥有比他大的monitor数量的状态转移过来,所以只要再加上买朋友的花费就好了。然而这样的思路不能保证记录的f[]最优,因为有monitor的影响,如果有monitor较少但f值较大的,他不会被更新,这是错误的。


我们发现由于所需要的监视器数量不同,所以我们要将监视器数量从小到大
排序,然后状压DP,因为后面所需监视器超过前面,所以我们不必再考虑监
视器够不够

https://www.cnblogs.com/hehe54321/p/cf-417d.html
先将小伙伴按需要的监视器数量排序。然后ans[i][j]表示前i个小伙伴完成j集合内题目所需最少钱。那么按顺序枚举小伙伴,用ans[i-1][j]更新ans[i][j]和ans[i][j | 第i个小伙伴能完成题目的集合](更新后一种时答案要加上第i个小伙伴的费用)。
由于小伙伴已经按监视器数量排序了,对于每个枚举出的小伙伴i,可以试着将其作为最后一个要求助的小伙伴,那么此时监视器上花的钱就是这个小伙伴所需监视器数量*每个的费用,求助小伙伴费用就是ans[i][所有题目的集合],此时总费用就是这两者的总和。最终答案就是最小的枚举得到的总费用。
可以开滚动数组优化空间。

https://xwk.iteye.com/blog/2130990
解题思路:dp[i],i为一个二进制数,表示完成这些题目的最小代价,但是这里要注意,因为有个监视器的数量,一般情况下要开一个二维的状态,但是2^20次方有一百万,再多一维的数组会超内存,所以我的做法是将每个小伙伴按照监视器的数量从小到达排序,慢慢向上加。
  1. typedef long long ll;  
  2. const int N = (1<<20)+5;  
  3. const int M = 105;  
  4. const ll INF = 0x3f3f3f3f3f3f3f3f;  
  5.   
  6. struct state {  
  7.     int s;  
  8.     ll k, val;  
  9. }p[M];  
  10. int n, m;  
  11. ll b, dp[N];  
  12.   
  13. bool cmp (const state& a, const state& b) {  
  14.     return a.k < b.k;  
  15. }  
  16.   
  17. void init () {  
  18.     memset(dp, -1, sizeof(dp));  
  19.   
  20.     scanf("%d%d", &n, &m);  
  21.     cin >> b;  
  22.   
  23.     int t, a;  
  24.     for (int i = 0; i < n; i++) {  
  25.         cin >> p[i].val >> p[i].k >> t;  
  26.         p[i].s = 0;  
  27.         for (int j = 0; j < t; j++) {  
  28.             scanf("%d", &a);  
  29.             p[i].s |= (1<<(a-1));  
  30.         }  
  31.     }  
  32.     sort(p, p + n, cmp);  
  33. }  
  34.   
  35. ll solve () {  
  36.     dp[0] = 0;  
  37.   
  38.     int t = (1<<m)-1;  
  39.     ll ans = INF;  
  40.     for (int i = 0; i < n; i++) {  
  41.   
  42.         for (int j = 0; j <= t; j++) {  
  43.             if (dp[j] == -1) continue;  
  44.   
  45.             int u = p[i].s | j;  
  46.   
  47.             if (dp[u] == -1)  
  48.                 dp[u] = p[i].val + dp[j];  
  49.             else   
  50.                 dp[u] = min(dp[u], p[i].val + dp[j]);  
  51.         }  
  52.   
  53.         if (dp[t] != -1)  
  54.             ans = min(ans, dp[t] + p[i].k * b);  
  55.     }  
  56.   
  57.     return ans == INF ? -1 : ans;  

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts